/////////////////////////////////////////////////
//	dcf77.c
//	
//	Auswertung des dcf77-signals
//	
//
//	Letzte nderung:	16.08.2006
//						Erstversion
//
/////////////////////////////////////////////////
//
#include "main.h"
#include "dcf77.h"
//
void dcf77_out(void)
{
	struct  DCF77_Bits *rx_buffer;		//Zeiger auf dc_buffer holen
	
	//ltere Zeitinformationen nutzen!
	//Werden u.U. von DCF Clock berschrieben
	mm = manclock_mn;
	hh = manclock_hr;

	//liegen neue Zeitinformationen vor?
	if(ui_dcfsreg & (1 << 0))
	{
		//Neue Zeitinformationen liegen vor
		ui_dcfsreg &= ~(1 << 0);
		//--> DCF Struktur holen
		rx_buffer = (struct DCF77_Bits *)(unsigned long long)&dc_buffer;

			//Prfen, ob Paritt von Stunden und Minuten gegeben ist
			if (((dcf77_bitcnt(rx_buffer->Min) % 2) == (rx_buffer->P1)) && ((dcf77_bitcnt(rx_buffer->Hour) % 2) == (rx_buffer->P2)) && rx_buffer->S)
			{
				ui_dcfsreg &= ~(1 << 3);		//parittsfehler rcksetzen
				//Gerade Paritt von Stunden und Minuten gegeben
				hh = dcf77_bcdtouint(rx_buffer->Hour);
				mm = dcf77_bcdtouint(rx_buffer->Min);
				day = dcf77_bcdtouint(rx_buffer->Day);
				mon = dcf77_bcdtouint(rx_buffer->Month);
				year = dcf77_bcdtouint(rx_buffer->Year);

				//Mit den Zeitinformationen der Funkuhr wird die manuelle Uhr
				//synchronisiert
				manclock_mn = mm;
				manclock_hr = hh;
			}
			else
			{
				ui_dcfsreg |= (1 << 3);			//parittsfehler setzen
			}
	}

	usart_int16str(hh);
	usart_senddata(':');
	usart_int16str(mm);
	usart_senddata(':');
	usart_int16str(manclock_ss);
	usart_senddata(' ');

	if((ui_dcfsreg & (1 << 2)) || (ui_dcfsreg & (1 << 3)))
	{
		usart_senddata('e');
	}
	else
	{
		usart_senddata('A');
	}
		usart_senddata(10);
		usart_senddata(13);
}

uint8_t dcf77_bitcnt(uint8_t ui_byte)
{
	uint8_t ui_tmp = 0;
	uint8_t ui_cnt = 0;

	for(ui_tmp = 0; ui_tmp < 8; ui_tmp++)
	{
		if(ui_byte & (1 << ui_tmp))
		{
			ui_cnt++;
		}
	}
	return ui_cnt;
}

uint8_t dcf77_bcdtouint(uint8_t ui_bcd)
{
	uint8_t ui_tmp = 0;
	
	ui_tmp = (ui_bcd >> 4) * 10;
	ui_tmp += (ui_bcd &= (0x0F));
	return ui_tmp;

}
