/////////////////////////////////////////////////
//	dcf77.h
//	
//	Auswertung des dcf77-signals
//	
//
//	Letzte nderung:	16.08.2006
//						Erstversion
//
/////////////////////////////////////////////////
//
//Funktionen und Strukturen zum DCF-Empfang
void dcf77_out(void);						//	Konvertiert und prft die Zeitinformationen; diese werden anschlieend ausgegeben
uint8_t dcf77_bitcnt(uint8_t ui_byte);		//	Zhlt die HIGH-Bits zur Parittsprfung (unschn!)
uint8_t dcf77_bcdtouint(uint8_t ui_bcd);	//Konvertiert die empfangenen BCD-Codierten informationen in UINT!

struct DCF77_Bits {
	unsigned long long M			:1	;
	unsigned long long O1			:1	;
	unsigned long long O2			:1	;
	unsigned long long O3			:1	;
	unsigned long long O4			:1	;
	unsigned long long O5			:1	;
	unsigned long long O6			:1	;
	unsigned long long O7			:1	;
	unsigned long long O8			:1	;
	unsigned long long O9			:1	;
	unsigned long long O10		:1	;
	unsigned long long O11		:1	;
	unsigned long long O12		:1	;
	unsigned long long O13		:1	;
	unsigned long long O14		:1	;
	unsigned long long R			:1	;
	unsigned long long A1			:1	;
	unsigned long long Z1			:1	;
	unsigned long long Z2			:1	;
	unsigned long long A2			:1	;
	unsigned long long S			:1	;
	unsigned long long Min		:7	;//7 Bits fr die Minuten
	unsigned long long P1			:1	;//Parity Minuten
	unsigned long long Hour		:6	;//6 Bits fr die Stunden
	unsigned long long P2			:1	;//Parity Stunden
	unsigned long long Day		:6	;//6 Bits fr den Tag
	unsigned long long Weekday	:3	;//3 Bits fr den Wochentag 
	unsigned long long Month		:5	;//3 Bits fr den Monat
	unsigned long long Year		:8	;//8 Bits fr das Jahr **eine 5 fr das Jahr 2005**
	unsigned long long P3			:1	;//Parity von P2
	};
